#include <pthread.h>

/* Posix threads wrapper to make code look more like programs
   in PoPP chapter 1. */

typedef void (*Proc)(int);

typedef struct elem_t {
  pthread_t t;
  Proc p;
  int v;
  struct elem_t *next;
} elem_t;
static elem_t *threads;

static void *start_proc(void *_e)
{
  elem_t *e = (elem_t *)_e;

  e->p(e->v);

  return NULL;
}

static void thread_create(Proc p, int v)
{
  elem_t *e;

  e = (elem_t *)malloc(sizeof(elem_t));

  e->next = threads;
  threads = e;

  e->p = p;
  e->v = v;

  pthread_create(&e->t, NULL, start_proc, e);
}

static void join_threads()
{
  elem_t *e = threads, *next;
  while (e) {
    pthread_join(e->t, NULL);
    next = e->next;
    free(e);
    e = next;
  }
  threads = NULL;
}

#define mutex pthread_mutex_t
#define INIT_MUTEX PTHREAD_MUTEX_INITIALIZER
#define mutex_lock(m) pthread_mutex_lock(&m);
#define mutex_unlock(m) pthread_mutex_unlock(&m);

#define MaxThreads 128
